# -*- coding: utf8 -*-

import re

ACCENTED_TO_ASCII = (
    ('ÀÁÂÃÄÅàáâãäåĀāĂăĄą', 'a'),
    ('Ææ', 'ae'),
    ('ÇçĆćĈĉĊċČč', 'c'),
    ('ÐðĎďĐđ', 'd'),
    ('ÈÉÊËèéêëĒēĔĕĖėĘęĚě', 'e'),
    ('ĜĝĞğĠġĢģ', 'g'),
    ('ĤĥĦħ', 'h'),
    ('ÌÍÎÏìíîïĨĩĪīĬĭĮįİ', 'i'),
    ('Ĳĳ', 'ij'),
    ('Ĵĵ', 'j'),
    ('Ķķĸ', 'k'),
    ('ĹĺĻļĽľĿŀŁł', 'l'),
    ('ÑñŃńŅņŇňŉŊŋ', 'n'),
    ('ÒÓÔÕÖØòóôõöøŌōŎŏŐő', 'o'),
    ('Œœ', 'oe'),
    ('ŔŕŖŗŘř', 'r'),
    ('ŚśŜŝŞşŠš', 's'),
    ('ŢţŤťŦŧ', 't'),
    ('ÙÚÛÜùúûüŨũŪūŬŭŮůŰűŲų', 'u'),
    ('Ŵŵ', 'w'),
    ('ÝýÿŶŷŸ', 'y'),
    ('Þþ', 'p'),
    ('ß', 'ss'),
    ('ŹźŻżŽž', 'z'),
)


def to_alphabetic(s):
    for (chars, replacement) in ACCENTED_TO_ASCII:
        s = re.sub('[' + chars + ']', replacement, s)

    return re.sub('[^a-z]', '', s.strip().lower())


def to_alphanumeric(s):
    for (chars, replacement) in ACCENTED_TO_ASCII:
        s = re.sub('[' + chars + ']', replacement, s)

    return re.sub('[^a-z0-9]', '', s.strip().lower())


def to_identifier(s):
    for (chars, replacement) in ACCENTED_TO_ASCII:
        s = re.sub('[' + chars + ']', replacement, s)

    s = re.sub('''[‘'’ |`]''', '_', s)

    return re.sub('[^A-Za-z0-9._-]', '', s)
